## A generalization of quasi-planarity

J´anos Pach, Radoˇs Radoiˇci´c, and G´eza T´othAbstract. A topological graph is a graph drawn in the plane by simple Jordan arcs. Suppose that a topological graphGhas nok+ 2 edges such that the first two cross each other and the remainingkedges. ThenGhas at mostCkn edges, for a suitable constantCk.

1. Introduction

Atopological graphis a graph drawn in the plane so that its vertices are repre- sented by points in the plane and its edges by simple (non-selfintersecting) Jordan arcs connecting the corresponding points and not passing through any vertex other than its endpoints. Throughout this paper, we assume that if two edges of a topo- logical graphGshare an interior point, then they properly cross at this point. We also assume, for simplicity, that no three edges cross at the same point and that any two edges cross only a finite number of times. LetV(G) andE(G) denote the vertex set and edge set of G, respectively. We will make no notational distinction between the vertices (edges) of the underlying abstract graph, and the points (arcs) representing them in the plane. If the edges of Gare represented by straight-line segments, then G is called a geometric graph. If, in addition, the vertices are in convex position, thenGis said to be aconvexgeometric graph.

It follows from Euler’s Polyhedral Formula that if a topological graph with n vertices has no pair of crossing edges, then its number of edges cannot exceed 3n−6. It is conjectured that for every fixedkthe maximum number of edges that a topological graph of nvertices can have without containing k pairwise crossing edges is O(n), where the constant hidden in the O-notation depends on k. For k= 3, this conjecture has been verified in [AAPPS97] for geometric graphs and in [PRT03] in full generality. For larger values ofk, the best upper bound known for the number of edges isntimes a polylogarithmic factor [V97], [PRT03]. For convex geometric graphsGwithn≥2kvertices, Capoyleas and Pach [CP92] found

2000Mathematics Subject Classification.Primary 05C10, 52C45; Secondary 05C35.

J´anos Pach has been supported by NSF Grant CCR-00-98246, by PSC-CUNY Research Award 65392-0034, and by OTKA T-032452.

Radoˇs Radoiˇci´c and G´eza T´oth has been supported by OTKA-T-038397 and by an award from the New York University Research Challenge Fund.

c

0000 (copyright holder) 1

an exact formula: ifGhas nok pairwise crossing edges, then

|E(G)| ≤2(k−1)n−

2k−1 2

, and this bound can be attained.

In [PPST03], it was shown that if a topological graphG withnvertices has nok×kgrid-like pattern, i.e., it has no 2k edges so that each of the firstk edges crosses the remaining ones, then|E(G)|=O(n).

The aim of the present note is to make another, albeit small, step towards the solution of the above problem, by proving

Theorem. For any fixed positive integerk, there exists a constantCk with the property that in every topological graph with n vertices and more than Ckn edges there are k+ 2 edges such that the first 2 cross each other and the remaining k edges.

In the literature, topological graphs with nokpairwise crossing edges are often calledk-quasi-planar.

2. Proof of Theorem.

LetG be a topological graph with nvertices, containing no k+ 2 edges such that the first 2 cross each other and the remainingkedges,k >1. We may assume without loss of generality that the underlying abstract graph of G is connected, because otherwise the theorem follows by induction on the number of vertices.

RedrawG, if necessary, without creating a forbidden (k+ 2)-tuple of edges, so that the number of crossings in the resulting topological graph ˜Gis as small as possible.

Obviously, no edge of ˜Gcan cross itself, otherwise we could reduce the number of crossings by removing the loop. Suppose that ˜Ghas two distinct edges that have at least two points in common. A region enclosed by two pieces of the participating edges is called alens.

Claim 1. Every lens ofG˜ contains a vertex.

Proof. Suppose there is a lens ` that contains no vertex of ˜G. Consider a
minimal lens`^{0} ⊆`, by containment. Notice that by swapping the two sides of `^{0},
we could reduce the number of crossings without creating any new pair of crossing
edges.

The following property is a direct consequence of a result of Schaefer and Ste- fankoviˇc on string graphs [SS01].

Claim 2. For any edge eofG˜and for anym >0, every set of2^{m}consecutive
crossings alonge involves at leastmdistinct edges other thane.

Lete1, e2, . . . , en−1∈E(G) be a sequence of edges such thate1, e2, . . . , ei form a treeTi⊆Gfor every 1≤i≤n−1. In particular,e1, e2, . . . , en−1form a spanning treeT :=Tn−1 ofG.

First, we construct a sequence of crossing-free topological graphs (trees), ˜T1,
T˜2, . . ., ˜Tn−1, as follows. Let ˜T1 be defined as a topological graph of two vertices,
consisting of the single edgee1(as was drawn in ˜G). Suppose that ˜Ti has already
been defined for some i≥1, and let v denote the endpoint of ei+1 that does not
belong toTi. Now add to ˜Ti the piece ofei+1 betweenv and its first crossing with
T˜i. More precisely, follow the edgeei+1 fromv up to the point v^{0} where it hits ˜Ti

for the first time, and denote this piece ofei+1 by ˜ei+1. Ifv^{0} is a vertex of ˜Ti, then
addvand ˜ei+1 to ˜Ti and let ˜Ti+1 be the resulting topological graph. Ifv^{0} is in the
interior of an edgeeof ˜Ti, then introduce a new vertex atv^{0}. It divides einto two
edges,e^{0} ande^{00}. Add both of them to ˜Ti, and deletee. Also addv and ˜ei+1, and
let ˜Ti+1be the resulting topological graph.

Aftern−2 steps, we obtain a topological tree ˜T := ˜Tn−1, which (1) is crossing- free, (2) has fewer than 2nvertices, (3) contains each vertex of ˜G, and (4) has the property that each of its edges is either afull edge, or apiece of an edgeof ˜G.

*e* *e* *e*

*e*

*T*
*e*

*e* ^{5}

*e*
*e*

*e* *e*
*e*

*e*

*e* *e*

*e**5*

*e*
*e*

*e*
*T*

*e*

*1* *e**2*

*9*
*6*

*7*

*4*

*3*

*10*

*8*

*6*
*7*

*1* *2*

*8*
*4*

*3*

*~*

*~*

*~* *~* *~* *~*

*~*

*~*

*~*

*~**9*

*10*

*~*

Figure 1. Constructing ˜T fromT

LetDdenote the open region obtained by removing from the plane every point belonging to ˜T. Define adirected convexgeometric graphH, as follows. Traveling around the boundary ofDin clockwise direction, we encounter two kinds of different

“features”: vertices and edges of ˜T. Represent each such feature by a different vertex xi ofH, in clockwise order in convex position. Note that the same feature will be represented by several xi’s: every edge will be represented twice, because we visit both of its sides, and every vertex will be represented as many times as its degree in ˜T. It is not hard to see that the number of verticesxi ∈V(H) does not exceed 8n.

Next, we define the edges ofH. LetE=E( ˜G\T) be the set of edges of ˜G\T. Direct the elements of E arbitrarily. Every edge e ∈ E may cross ˜T at several points. These crossing points divide einto several pieces, called segments. LetS denote the set of all directed segments of all edgese∈ E. With the exception of its endpoints, every segment s∈ S runs in the regionD. Both the starting point and endpoint ofsbelong to a feature along the boundary ofD, represented by two vertices of H, xi and xj, respectively. Connectxi and xj by a straight-line edge

−−→xixj∈E(H), directed fromxi toxj.

Notice that H has no loops, because ifxi =xj,then, using the fact that ˜T is connected, one can easily conclude that the lens enclosed bys and by the edge of T˜corresponding toxi has no vertex of ˜Gin its interior. This contradicts Claim 1.

Of course, several different segments may give rise to the same directed edge

−−→xixj∈E(H). Two such segments are said to be of the same type.

Claim 3. (i)H has nok+ 2 pairwise crossing edges.

(ii) |E(H)| < 32(k+ 1)n, i.e., the number of different types of segments is smaller than 32(k+ 1)n.

Proof. To prove part (i), observe that if two edges ofH cross each other, then the “features” of ˜Tcorresponding to their endpoints alternate in the clockwise order

around the boundary ofD. Therefore, ifH hadk+ 2 pairwise crossing edges, they would correspond tok+ 2 pairwise crossing edges inE, which is a contradiction.

Part (ii) immediately follows from part (i) and the Capoyleas-Pach theorem [CP92] quoted in the introduction, because we have

|E(H)| ≤2

2(k+ 1)|V(H)| −

2k+ 3 2

<32(k+ 1)n.

Note that each undirected edge corresponds to two directed edges.

For any two oriented edges, a and b, crossing at some point X, we say that a crosses b from left to right if the direction of a at X can be obtained from the direction ofb atX by a clockwise turn of less thanπ.

Consider a directed edge −−→xixj∈E(H),wherexi, the tail, represents a feature
fi (edge or vertex) along the boundary of R^{2}\T˜. Consider all segments of type

−−→xixj. Iffi is a vertexv, then order all segments according to the counterclockwise order as they emanate fromv. If fi is an edge, take an orientation offi such that fi crosses each of the segments (more precisely, the corresponding edges) from left to right, and order the segments according to the order they crossfi.

This order is called thetail orderof the segments of a given type.

A segments ∈ S is said to beshielded if there are at least 5k4^{k} segments of
the same type, belonging to different edges ofE,precedingsand at least 5k4^{k}such
edges comingaftersin the tail order. Otherwise,sis calledexposed. Anedgee∈E
is calledexposedif at least one of its segments is exposed. Otherwise, it isshielded.

In view of Claim 3 (ii), there are fewer than 32(k+ 1)n different types of
segments. The maximum number of exposed segments of a given type which belong
to different edges is 10k4^{k}+ 2. Thus, we have obtained

Claim 4. The number of exposed edges of E =E( ˜G\T)is at most 320(k+
1)^{2}4^{k}n.

In order to prove the theorem, it is sufficient to show that there are no shielded edges (Claim 6).

Consider a shielded edgee=−uv→∈E. Lete1, e2, . . . , em−1denote the edges of T˜cutting e, listed according to the orientation ofe. They cut eintom segments, s1, s2, . . . , sm,of typesτ1, τ2, . . . , τm, respectively.

For a fixed 1≤i≤m, take a segment r of type type(r) =τi that belongs to
a directed edgef ∈E. Consider all segments of type τi strictly between si and r
in the tail order, and assume that they altogether belong tod(r) different edges of
E. We need a simple relation between the values ofdfor two consecutive segments
along the same edge. If i < m(i >1, resp.), then let r^{+} (resp., r^{−}) denote the
segment immediately following (resp., immediately preceding)ralong the directed
edgef.

Claim 5. Suppose thatd(r)≤4k4^{k}.

(i) If i < m, thentype(r^{+}) =τi+1 andd(r^{+})≤d(r) + 2k.

(ii) Ifi >1, thentype(r^{−}) =τi−1 andd(r^{−})≤d(r) + 2k.

Proof. By symmetry, it is sufficient to prove part (i). We can assume without loss of generality thatsi precedesrin the tail order of all segments of typeτi.

Letαandβ denote the heads ofrandsi, respectively. Assume without loss of generality thatαcomes afterβ in the tail order alongei. (The other case can be treated similarly.) LetBandAdenote the sets of segments of typeτi+1 that come

before si+1 and after si+1, resp., in the tail order. Furthermore, let A1 (and A2) consist of all elements ofAwhose tails lie strictly betweenαandβ (come afterα, respectively).

Suppose, in order to obtain a contradiction, that type(r^{+})6=τi+1.It is easy to
see, using Claim 1, that nowr^{+} must cross either all elements ofBor all elements
ofA2 (see Fig. 2).

In the first case, note that, sincee(and thereforesi+1) is shielded, the segments
in B belong altogether to at least 5k4^{k} > k different edges of E. These edges,
together withei andf, would form a forbidden configuration.

So we are left with the case when r^{+} intersects all segments in A2. If these
segments belong to at least k different edges of E, then again we are done. If
they belong to fewer thankedges, then the elements ofA1must belong altogether
to more than 5k4^{k}−k different edges. All of these edges leave the quadrilateral
enclosed by ei−1, ei, r, and si, through its side lying on ei. If at leastk of them
crossf or at leastk of them crosse, then they, together with ei andf (resp.,e),
form a forbidden configuration. Therefore, all but at most 2k−2 of them must
once enter the quadrilateral throughei−1. However, in this case, there are at least
5k4^{k}−k+ 1−(2k−2)>4k4^{k} different edges containing a segment of typeτi that
lies betweensiandr. That is, we haved(r)>4k4^{k}, contradicting our assumption.

Thus, we have shown that type(r^{+}) =τi+1. Recall thatA1 denotes the set of
all segments of this type that lie strictly between si+1 andr^{+} in the tail order of
all edges of this type. Then d(r^{+}) is equal to the number of different edges that
contribute at least one segment toA1. Suppose, in order to obtain a contradiction,
thatd(r^{+})> d(r) + 2k, i.e., there are more thand(r) + 2kdifferent edges inEthat
leave the quadrilateral enclosed byei−1,ei,r, andsi, through its side that belongs
toei. Just like before, we find that at mostk−1 of them can crossrand at most
k−1 can cross si. Therefore, more than d(r) + 2k−2(k−1)> d(r) edges must
cross the side belonging toei−1. This contradicts the definition ofd(r).

*s*_{i}*s*_{i+}_{1}

*r* *r*

β α

*e*_{i-}*1* *e*_{i}*e*_{i+}*1*

*s*_{i}*s*_{i+}_{1}*r*

β α

*e*_{i-}*1* *e*_{i}*e*_{i+}*1*

*s*_{i}*s*_{i+}_{1}*r*

β α

*e*_{i-}*1* *e*_{i}*e*_{i+}*1*

*e*

*f* *r*

*r*

*+*

*+*

*+*

Figure 2. type(r^{+}) =τi+1 andd(r^{+})≤d(r) + 2k.

Now we are in a position to complete the proof of the theorem by proving the following assertion.

Claim 6. There are no shielded edges inE.

Proof. As before, suppose that there exists a shielded edge e = −uv→ with segmentssi of typeτi (1≤i≤m). Consider all segments of type τ1. The tail of each of them isu, so they cannot cross one another, by Claim 1.

Let t1 be the segment that follows immediately after s1 in the tail order of all segments of type τ1, so that we have d(t1) = 0. Denote by g the edge of E

that contains t1, and let t2, . . . , tν denote the other segments of g. By repeated
application of Claim 5 (i), we obtain that ti is of type τi for all 1 ≤ i ≤ 4^{k}.
Consequently, we have 4^{k}< m, 4^{k}< ν, andd(t4^{k})≤2k4^{k}.

The graphGhas no parallel edges, so the endpoint (head) ofgis different from
v, the endpoint ofe. Thus, there exists a smallest integerµ(4^{k}< µ), for which the
type of tµ is notτµ. By Claim 5 (i), we have d(tµ−1)>4k4^{k}. Choose an integer
λ(4^{k} ≤λ < µ) such that d(tλ) ≤2k4^{k} and d(tλ)< d(tλ+1). Consider all edges
that have a segment of type τλ+1 betweensλ+1 andtλ+1 in the tail order. All of
these edges leave the quadrilateralQenclosed byeλ−1, eλ, sλ, andtλ through its
side belonging toeλ. Sinced(tλ)< d(tλ+1), at least one of them must have entered
Q either through sλ or through tλ. Suppose, for instance, that there is such an
edgef ∈E intersectingtλ (the other case can be handled similarly). Letr1, r2, . . .
denote the segments off. Then f intersects g and, for someκ, the segmentrκ+1

is of typeτλ+1 (see Fig. 3).

λ λ+*1*

*e* *e*

λ λ+*1*

*t* *t*

*e*

λ−

_{4}*e*

_{λ−}

_{1}*e*

_{1}*r*

κ *r*

_{κ+1}

*k*

*f* *g* *e*

*s*

_{λ}

*s*

_{λ+}

_{1}Figure 3. f andgcross each other and both of them crosseλ, eλ−1, . . . , eλ−4^{k}.
Since

d(rκ+1)≤d(tλ+1)≤2k4^{k}+ 2k,

by repeated application of Claim 5 (ii), we can conclude that κ ≥ 4^{k} and for
0≤i < 4^{k}, type(rκ−i) = τλ−i. In particular, we obtain thatf and g cross each
other and both of them crosseλ, eλ−1, . . . , eλ−4^{k}. Let

¯ g=

4^{k}−1

[

i=1

tλ−i.

We show that any edge that crosses ¯g, must also cross either f, or e_{λ}_{−}_{4}^{k}. For
0< i <4^{k}, letQibe the quadrilateral bounded byeλ−i,tλ−i,eλ−i−1, andrκ−i. Let
Q0be the triangular region bounded byeλ−1,tλ, andrκ(recall that, by assumption,
tλ and rκ cross each other.) Suppose that there is an edge hthat intersects ¯g but
does not intersectf. Then, for somej, 0< j <4^{k},hcrossestλ−j, so, depending on
its orientation,henters or leavesQj, through its side tλ−j. Suppose that itenters
Qjthroughtλ−j, the other case is analogous. Since there is no vertex inQj, hmust
leave it through one of its sides. It cannot leave throughtλ−j, because thenhand
tλ−j would form an empty lens, contradicting Claim 1. It cannot leave through
rκ−j, sincehdoes not crossf. So it leaves either througheλ−j−1, or througheλ−j.

Case 1: hleavesQj througheλ−j. ThenhentersQj−1. It cannot leave Qj−1

througheλ−j or throughtλ−j+1, because then it would create an empty lens, and it cannot leave through rκ−j+1, sincehdoes not crossf. Therefore,hmust leave Qj−1througheλ−j+1, and then it must enterQj−2. By repeated application of the above argument, we conclude that hentersQ0 througheλ−1. However, it cannot leaveQ0through any of its sides, which is a contradiction.

Case 2: h leaves Qj through eλ−j−1. Then it enters Qj+1. We can argue
exactly as in Case 1 that h crosseseλ−j−2, eλ−j−3, and eventually it must cross
eλ−4^{k}.

We know that there are at least 4^{k} crossings on ¯g, so by Claim 2 they corre-
spond to at least 2k different edges. Each of them also crosses eitherf or eλ−4^{k}.
Thus, either at least kof them crossf or at leastk of them crosseλ−4^{k}. Thesek
edges, together with g, and either with f or with eλ−4^{k}, would form a forbidden
configuration.

References

[AAPPS97] P. K. Agarwal, B. Aronov, J. Pach, R. Pollack, and M. Sharir: Quasi-planar graphs have a linear number of edges,Combinatorica17(1997), 1–9.

[CP92] V. Capoyleas and J. Pach: A Tur´an-type theorem on chords of a convex polygon,Journal of Combinatorial Theory, Series B56(1992), 9–15.

[PPST03] J. Pach, R. Pinchasi, M. Sharir, and G. T´oth: Topological graphs with no large grids, to appear.

[PPTT02] J. Pach, R. Pinchasi, G. Tardos, and G. T´oth: Geometric graphs with no self- intersecting path of length three, in: Graph Drawing (M. T. Goodrich, S. G. Kobourov, eds.), Lecture Notes in Computer Science2528, Springer-Verlag, Berlin, 2002, 295–311.

[PRT03] J. Pach, R. Radoiˇci´c, and G. T´oth: Relaxing planarity for topological graphs, to appear.

[SS01] M. Schaefer and D. Stefankoviˇc, Decidability of string graphs, in:Proceedings of the 33rd Annual Symposium on the Theory of Computing (STOC 2001), 2001, 241–246.

[V97] P. Valtr: Graph drawing with nokpairwise crossing edges, in: Graph Drawing (Rome, 1997), Lecture Notes in Comput. Sci.1353, Springer, Berlin, 1997, 205–218.

City College, CUNY and Courant Institute of Mathematical Sciences, New York University, New York, NY, USA

E-mail address: pach@cims.nyu.edu

Department of Mathematics, Massachusetts Institute of Technology, Cambridge, MA, USA

E-mail address: rados@math.mit.edu

R´enyi Institute, Hungarian Academy of Sciences, Budapest, HUNGARY E-mail address: geza@renyi.hu